/*
 *   Copyright (c) International Business Machines  Corp., 2001
 *
 *   This program is free software;  you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY;  without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program;  if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Module: dm-ioctl.h
 *
 * Functions exported from dm-ioctl3.c and dm-ioctl4.c to dm.c. Only dm.c
 * should include this header file.
 */

#ifndef _DM_IOCTL_H_INCLUDED_
#define _DM_IOCTL_H_INCLUDED_ 1

/* Version 3 APIs */
extern int run_command_v3(void *dmi, unsigned long command);
extern int dm_suspend_v3(storage_object_t *object, int suspend);
extern int dm_activate_v3(storage_object_t *object, dm_target_t *target_list);
extern int dm_activate_volume_v3(logical_volume_t *volume, dm_target_t *target_list);
extern int dm_deactivate_v3(storage_object_t *object);
extern int dm_deactivate_volume_v3(logical_volume_t *volume);
extern int dm_rename_v3(storage_object_t * object, char * old_name, char * new_name);
extern int dm_rename_volume_v3(logical_volume_t * volume, char * old_name, char * new_name);
extern int dm_update_status_v3(storage_object_t *object);
extern int dm_update_volume_status_v3(logical_volume_t *volume);
extern int dm_get_targets_v3(storage_object_t *object, dm_target_t **target_list);
extern int dm_get_info_v3(storage_object_t *object, char ** info);
extern int dm_get_version_v3(int *major, int *minor, int *patch);

#endif

